import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * 
 * 
 * @author Romuald Apothélos
 * @author Boris Méan 
 * 
 * @version 05.01.2022
 */
public class Aim extends Actor
{
    public String left;
    public String right;
    public String turnup;
    public String turndown;
    public String shoot;
    public String cancel;
    public boolean stop = false;
    public boolean faceLeft = false;
    public Player player;
    public boolean Lpress = false;
    public boolean Rpress = false;
    public int damage;
    /**
     * constructor, with the two key to turn the aim and the 
     */
    public Aim(String key1,String key2,boolean left,String key3, String key4,Player player,String key5,String key6,int angle,int dg)
    {
        this.left = key1;
        right = key2;
        cancel = key3;
        shoot = key4;
        turnup = key5;
        turndown = key6;
        this.player = player;
        damage = dg;
        if(left && angle==0)
        {
            turn(180);
            faceLeft=true;
        }
        turn(angle);
    }
    /**
     * Act - do whatever the aim wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        aiming();
        if(shoot()){return;};
        if(search()){return;};
    }
    /**
     * Shoot - create a bullet and remove the aim
     */
    public boolean shoot()
    {
        if(!Greenfoot.isKeyDown(cancel))
        {
            player.setAimAngle(this.getRotation());
            stop = true; 
        }
        if(Greenfoot.isKeyDown(shoot) && stop)
            {
            player.setAimAngle(this.getRotation());
            player.shoot();
            player.mun();
            getWorld().removeObject(this);
            return true;
        }
        if(Greenfoot.isKeyDown(cancel)&& stop)
        {
            player.shoot(1);
            getWorld().removeObject(this);
            return true;
        }
        return false;
    }
    /**
     * Aiming - turn the object to aim
     */
    public void aiming()
    {
        if(Greenfoot.isKeyDown(left)&&!faceLeft&&!Lpress)
        {
            faceLeft=true;
            Lpress = true;
            if(this.getRotation()<180)
            {
                int turn= 2*(90-this.getRotation());
                turn(turn);
            }else
            {
                int turn= 2*(270-this.getRotation());
                turn(turn);
            }
        }
        else if(!Greenfoot.isKeyDown(left)&&Lpress)
        {
            Lpress=false;
        }
        if(Greenfoot.isKeyDown(right)&&faceLeft&&!Rpress)
        {
            faceLeft=false;
            Rpress = true;
            if(this.getRotation()<180)
            {
                int turn= 2*(90-this.getRotation());
                turn(turn);
            }else
            {
                int turn= 2*(270-this.getRotation());
                turn(turn);
            }
        }
        else if(!Greenfoot.isKeyDown(right)&&Lpress)
        {
            Rpress=false;
        }
        if((Greenfoot.isKeyDown(turnup)&&faceLeft) || (Greenfoot.isKeyDown(turndown)&&!faceLeft))
        {
            turn(-1);
        }
        if((Greenfoot.isKeyDown(turnup)&&!faceLeft) || (Greenfoot.isKeyDown(turndown)&&faceLeft))
        {
            turn(1);
        }
    }
    /**
     * Search - make sure there is always a player. 
     */
    public boolean search()
    {
        if (null == getOneIntersectingObject(Player.class))
        {
            getWorld().removeObject(this);
            return true;
        };
        return false;
    }
    /**
     * setLeft - define if the caracther is facing left or right
     */
    public void setLeft()
    {
        faceLeft=true;
    }
}
