import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * A variation of SmoothMover that keep visualy track of time.
 * 
 * @author Romuald Apothélos
 * @author Boris Méan 
 * 
 * @version 15.01.2022
 */
//3100 tick (speed : 49) ~= 1 min
//down = 760 / 299
//up = 760 / 161
public class Flag extends SmoothMover
{
    public int clock = 0;
    public int distance = 3100; 
    public int y = 760;
    public int down = 299;
    public int up = 161;
    public boolean count;
    public Landscape land;
    int life = 10000;
    /**
     * constructor of the clas Flag
     */
    public Flag(int gm, int info, Landscape landscape)
    {
        land = landscape;
        if(gm==0)
        {
            addForce (new Vector (0.0,(double)(up-down)/(distance*info)));
            count = true;
        }
    }
    /**
     * Act - do whatever the Flag wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        clock++;
        if(getY()>=162){
            move();
        }
        else if(count)
        {
            int team = 0;
            List<Player> player = (List<Player>) getWorld().getObjects(Player.class);
            for (Player play : player) 
            {
                if(play.getKill()>team){team=play.getTeam();}
            }
            getWorld().addObject(new GameOver(team),600,300);
        }
    }
    /**
     * hurt - reduce the life of the flag, usefull for the easteregg
     */
    public void hurt(int dm,Actor killer)
    {
        life=life-dm;
        if(life<=0)
        {
            
            List<Player> player = (List<Player>) getWorld().getObjects(Player.class);
            for (Player play : player) 
            {
                if (play==killer )
                {
                   play.berset();
                   life=1000000;
                }
            }
        }
    }
    /*
     * to find position for the flag
     * only use for debbuging
    public void right(int i)
    {
        setLocation(getX()+i,getY());
    }
    public void left(int i)
    {
        setLocation(getX()-i,getY());
    }
    public void up(int i)
    {
        setLocation(getX()+i,getY());
    }
    public void down(int i)
    {
        setLocation(getX()+i,getY());
    }
    public void get()
    {
        System.out.println("X : "+getX()+"/tY : "+getY());
    }
    */
    /**
     * getTime - return the time, as the flag is the main clock
     */
    public int getTime()
    {
        return clock;
    }
    /**
     * Stopsound - stop the music
     */
    public void stopSound()
    {
        land.endSound();
    }
}
