import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class GameOver here.
 * 
 * 
 * 
 * @author Romuald Apothélos 
 * @author Boris Méan 
 * 
 * @version 15.01.2022
 */
public class GameOver extends Actor
{
    public int width = 1200;
    public int height = 600;
    public int team;
    GreenfootImage display = new GreenfootImage(width, height);
    /**
     * constructor of the classe GameOver
     */
    public GameOver(int tm)
    {
        team = tm;
        GreenfootSound sound = new GreenfootSound("endSong.mp3");
        sound.play();
    }
    /**
     * Act - do whatever the GameOver wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        display.setColor(new Color(20,20,20, 199));
        display.fillRect(20, 20, width-40, height-40);
        Font font = display.getFont();
        font = font.deriveFont(52);
        display.setFont(font);
        display.setColor(Color.WHITE);
        display.drawString("Sonderbund", 480 , 80);
        font = font.deriveFont(40);
        display.setFont(font);
        display.drawString("Winners : ",40 , 200);
        display.setColor(Color.WHITE);
        font = font.deriveFont(100);
        display.setFont(font);
        List<Platform> platfrom = (List<Platform>) getWorld().getObjects(Platform.class);
       List<Player> player = (List<Player>) getWorld().getObjects(Player.class);
       List<Obstacle> obstacle = (List<Obstacle>) getWorld().getObjects(Obstacle.class);
       List<Flag> flag = (List<Flag>) getWorld().getObjects(Flag.class);
       List<weapon> weapon = (List<weapon>) getWorld().getObjects(weapon.class);
       List<UI> ui = (List<UI>) getWorld().getObjects(UI.class);
       List<lifeBar> lifebar = (List<lifeBar>) getWorld().getObjects(lifeBar.class);
       List<Explosion> explosion = (List<Explosion>) getWorld().getObjects(Explosion.class);
       int x = 0;

       
        for (Platform plat : platfrom) 
        {
            getWorld().removeObject(plat);
        }
        for (Player play : player) 
        {
            getWorld().removeObject(play);
            if(play.getTeam()==team)
            {
                x++;
                display.drawString(("Player "+String.valueOf(play.getKey()+1)), 440 , 200+100*x);
            }
        }
        for (Obstacle obs : obstacle) 
        {
            getWorld().removeObject(obs);
        }
        for (Flag fl : flag) 
        {
            fl.stopSound();
            getWorld().removeObject(fl);
        }
        for (weapon wp : weapon) 
        {
            getWorld().removeObject(wp);
        }
        for (UI u : ui) 
        {
            getWorld().removeObject(u);
        }
        for (lifeBar lb : lifebar) 
        {
            getWorld().removeObject(lb);
        }
        for (Explosion ex : explosion) 
        {
            getWorld().removeObject(ex);
        }
        setImage(display);
        Greenfoot.stop();
    }
}
