import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * This class is the world, it also takes care of making all the different elements appear and finish the game.
 * 
 * @author Romuald Apothélos 
 * @author Boris Méan 
 * 
 * @version 15.01.2022
 */
public class Landscape extends World
{
    public Menu menu;
    public start start;
    GreenfootSound sound = new GreenfootSound("game.mp3");
    /**
     * Constructor for objects of class Landscape.
     * 
     */
    public Landscape()
    {    
        // Create a new world with 1200x600 cells with a cell size of 1x1 pixels.
        super(1200, 600, 1); 
        
        Greenfoot.start();
        
        start = new start();
        menu = new Menu(start,this);
        addObject(menu,600,300);
        addObject(start,765, 500);
        //addObject(new GameOver(1),600,300);
    }
    /**
     * wallAndGround -set the walls and the platforms
     */
    public void wallAndGround(boolean gm)
    {
        //Loop to create the ground of the stage
        for(int i=50; i<=1200; i=i+100){
            addObject(new Platform(false,gm),i,600);
        }
        
        //Create Platform for the top of the mountain
        addObject(new Platform(true,gm),191,206);
        addObject(new Platform(true,gm),262,206);
        
        //Create Platform for the middle of the mountain
        addObject(new Platform(true,gm),105,350);
        addObject(new Platform(true,gm),205,350);
        addObject(new Platform(true,gm),305,350);
        addObject(new Platform(true,gm),340,350);
        
        //Create Platform for the bottom of the mountain
        addObject(new Platform(true,gm),63,490);
        addObject(new Platform(true,gm),153,490);
        addObject(new Platform(true,gm),253,490);
        addObject(new Platform(true,gm),353,490);
        addObject(new Platform(true,gm),430,490);
        
        //Create Platform for the 
        addObject(new Platform(false,gm),1090,465);
        addObject(new Platform(false,gm),1190,465);
        
        //Create Platform for the second floor of the house
        addObject(new Platform(false,gm),1150,355);
        addObject(new Platform(false,gm),1050,355);
        addObject(new Platform(false,gm),950,355);
        addObject(new Platform(false,gm),880,355);
        
        //Create Platform for the shelf
        addObject(new Platform(true,gm),1125,307);
        addObject(new Platform(true,gm),1165,262);
        
        //Create Platform for the loft
        addObject(new Platform(false,gm),1240,215);
        addObject(new Platform(false,gm),1050,215);
        addObject(new Platform(false,gm),950,215);
        addObject(new Platform(false,gm),870,215);
        
        //Create Wall for the house
        addObject(new Wall(),829,375);
        addObject(new Wall(),829,465);
        
        
        List<Platform> platfrom = (List<Platform>) getObjects(Platform.class);
        for (Platform plat : platfrom) 
        {
            plat.populate();
        }
    }
    /**
     * start - start the game
     */
    public void startGame(int p1, int p2, int p3, int t1, int t2, int t3, int gm, int info,int im1,int im2,int im3)
    {
        sound.setVolume(30);
        sound.playLoop();
        removeObject(menu);
        removeObject(start);
        if(t1!=3){addObject(new Player(0,gm,t1,0,0,info,im1),300,500);}
        if(t2!=3){addObject(new Player(1,gm,t2,0,0,info,im2),400,500);}
        if(t3!=3){addObject(new Player(2,gm,t3,0,0,info,im3),900,500);}
        if(gm!=3){wallAndGround(true);}else{wallAndGround(false);}
        if(gm!=0){addObject(new Flag(gm,info,this),760,161);}else{addObject(new Flag(gm,info,this),760,299);}
        Greenfoot.setSpeed(49);
    }
    /**
     * endSound - stop the music 
     */
    public void endSound()
    {
        sound.stop();
    }
}
