import greenfoot.*;
import rccookie.greenfoot.ui.basic.*;
import rccookie.greenfoot.ui.advanced.*;
import rccookie.greenfoot.ui.util.*;
import rccookie.greenfoot.ui.advanced.DropDownMenu;
import rccookie.greenfoot.ui.advanced.Switch;
import rccookie.greenfoot.ui.basic.IconButton;
import rccookie.greenfoot.ui.basic.Text;
import rccookie.greenfoot.ui.basic.TextButton;
import rccookie.greenfoot.ui.basic.UIWorld;
import rccookie.greenfoot.ui.util.Design;
import rccookie.greenfoot.ui.util.Theme;
import rccookie.greenfoot.ui.util.UIElement;
import java.util.List;


/**
 * Allows you to select your character, team and game mode
 * 
 * @author Romuald Apothélos
 * @author Boris Méan 
 * 
 * @version 15.01.2021
 */
public class Menu extends Actor
{
    public int width = 1200;
    public int height = 600;
    public int[] player = {0,0,0};
    public int[] team = {3,3,3};
    public int gameMode = 0;
    public int[] modeInfo = {1,20,3};
    public String[] text = {"Time", "kill", "kill Streak","jeu d'arme","At the end of the timer",", the one whit most ","kills win (in min)","the first to reach the","number specified of","kills win","the first to reache the","number specifed of","kill in a row wins.","eache time you kill","someone,you get a","new weapon. The first"," one to go through","the 6 weapons win","team 1","team 2","team 3","no player"};
    public int Player;
    public Actor start;
    public Landscape land;
    public String[] avatar = {"armailli 2.png","culotte 2.png","genevois 2.png","vache 2.png"};
    GreenfootImage menu = new GreenfootImage(width, height);
    GreenfootImage image = new GreenfootImage(width, height);
    GreenfootImage Iplayer = new GreenfootImage(width, height);
    GreenfootImage Iteam = new GreenfootImage(width, height);
    GreenfootImage IgameMode = new GreenfootImage(width, height);
    GreenfootSound Smenu = new GreenfootSound("menu.mp3");
    /**
     * Constuctor of the classe
     */
    public Menu(Actor st, Landscape ld)
    {
        start = st;
        land = ld;
        Smenu.playLoop();  
        Smenu.setVolume(50);
        background();
        Iplayer();
        Iteam();
        IgameMode.setColor(new Color(10,10,10,200));
        IgameMode.fillRect(585,120,180,300);
        IgameMode.fillRect(770,120,180,300);
        IgameMode.fillRect(955,120,180,300);
        
        Update();
        
        Greenfoot.setSpeed​(30);
    }
    /**
     * Act - do whatever the Menu wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        player();
        team();
        gamemode();
        if(Greenfoot.mousePressed(start)){start();}
        Update();
    }
    /**
     * Player - let the player choose his carachter
     */
    public void player()
    {
        if(Greenfoot.isKeyDown("w") || Greenfoot.isKeyDown("d")){player[0]=(player[0]+1)%4;}
        if(Greenfoot.isKeyDown("a") || Greenfoot.isKeyDown("s")){if(player[0]>0){player[0]--;}else{player[0]=3;}}
        if(Greenfoot.isKeyDown("j") || Greenfoot.isKeyDown("z")){player[1]=(player[1]+1)%4;}
        if(Greenfoot.isKeyDown("g") || Greenfoot.isKeyDown("h")){if(player[1]>0){player[1]--;}else{player[1]=3;}}
        if(Greenfoot.isKeyDown("right") || Greenfoot.isKeyDown("up")){player[2]=(player[2]+1)%4;}
        if(Greenfoot.isKeyDown("left") || Greenfoot.isKeyDown("down")){if(player[2]>0){player[2]--;}else{player[2]=3;}}
        Iplayer();
    }
    /**
     * Team - let the player choose his team 
     */
    public void team()
    {
        if(Greenfoot.isKeyDown("q")){team[0]=(team[0]+1)%4;};
        if(Greenfoot.isKeyDown("t")){team[1]=(team[1]+1)%4;};
        if(Greenfoot.isKeyDown("-")){team[2]=(team[2]+1)%4;};
        Iteam();
    }
    /**
     * Gamemode - let the player choose his game mode
     */
    public void gamemode()
    {
        if(Greenfoot.getMouseInfo()!=null)
        {
            if(Greenfoot.getMouseInfo().getButton()==1 && Greenfoot.getMouseInfo().getClickCount()<=1)
            {
                int x = Greenfoot.getMouseInfo().getX();
                int y = Greenfoot.getMouseInfo().getY();
                if(580>=x && x>=400 && y>=120 && y<=420)
                {
                    gameMode = 0;
                }
                if(765>=x && x>=585 && y>=120 && y<=420)
                {
                    gameMode = 1;
                }
                if(950>=x && x>=770 && y>=120 && y<=420)
                {
                    gameMode = 2;
                }
                if(1135>=x && x>=955 && y>=120 && y<=420)
                {
                    gameMode = 3;
                }
            }
        }
        
        for(int i = 0; i<10;i++)
        {
            if(Greenfoot.isKeyDown(String.valueOf(i))){modeInfo[gameMode]=modeInfo[gameMode]*10+i;};
        }
        if(Greenfoot.isKeyDown("backspace")){modeInfo[gameMode]=modeInfo[gameMode]/10;}
        IgameMode();
    }
    /**
     * Background - set the image for the background of the menu
     */
    public void background()
    {
        image.setColor(new Color(20,20,20, 199));
        image.fillRect(20, 20, width-40, height-40);
        Font font = image.getFont();
        font = font.deriveFont(52);
        image.setFont(font);
        image.setColor(Color.WHITE);
        image.drawString("Sonderbund", 480 , 80);
        font = font.deriveFont(20);
        image.setFont(font);
        image.drawString("Choose your character and team",40 , 100);
        image.drawString("player    move        team",40 , 120);
        image.setColor(new Color(255,0,0,255));
        image.drawString("1           a,w,s,d     q",40 , 140);
        image.setColor(new Color(0,255,0,255));
        image.drawString("2           g,h,z,d      t",40 , 160);
        image.setColor(new Color(0,0,255,255));
        image.drawString("3           arrows      -",40 , 180);
        for(int i=0;i<2;i++)
        {
            for(int j=0;j<2;j++)
            {
                image.setColor(new Color(10,10,10, 220));
                image.fillRect(80+120*j,220+120*i , 100, 100);
                image.setColor(new Color(220,220,220, 220));
                image.fillRect(90+120*j,230+120*i , 80, 80);
                if(i==0){image.drawImage(new GreenfootImage(avatar[0+j]),90+120*j,230+120*i);}
                if(i==1){image.drawImage(new GreenfootImage(avatar[2+j]),90+120*j,230+120*i);}
            }
        }
        
        
        image.setColor(new Color(125,125,125,220));
        image.fillRect(80,460,100,30);
        image.fillRect(200,460,100,30);
        image.fillRect(140,500,100,30);
        
        
        for(int i=0;i<4;i++)
            {
                image.setColor(new Color(10,10,10, 220));
                image.fillRect(400+185*i,120 , 180, 300);
            }
        font = font.deriveFont(24);
        image.setFont(font);
        image.setColor(new Color(255,255,255,255));
        image.drawString(text[0],460 ,150);
        image.drawString(text[1],660 ,150);
        image.drawString(text[2],810 ,150);
        image.drawString(text[3],990 ,150);
        font = font.deriveFont(18);
        image.setFont(font);
        image.drawString(text[4],405 ,200);
        image.drawString(text[5],415 ,218);
        image.drawString(text[6],425 ,236);
        image.drawString(text[7],595 ,200);
        image.drawString(text[8],595 ,218);
        image.drawString(text[9],640 ,236);
        image.drawString(text[10],775 ,200);
        image.drawString(text[11],780 ,218);
        image.drawString(text[12],790 ,236);
        image.drawString(text[13],970 ,200);
        image.drawString(text[14],968 ,218);
        image.drawString(text[15],955 ,236);
        image.drawString(text[16],968 ,254);
        image.drawString(text[17],970 ,272);
        
        for(int i=0;i<3;i++)
            {
                image.setColor(new Color(255,255,255, 255));
                image.fillRect(440+185*i,380 ,100, 20);
            }
    }
    /**
     * Iplayer - set the image for the charachter choice
     */
    public void Iplayer()
    {
        Iplayer.clear();
        Iplayer.setColor(new Color(255,0,0, 255));
        Iplayer.fillRect(playerPos(player[0])[0],playerPos(player[0])[1] , 30, 10);
        Iplayer.setColor(new Color(0,255,0, 255));
        Iplayer.fillRect(playerPos(player[1])[0]+30,playerPos(player[1])[1] , 30, 10);
        Iplayer.setColor(new Color(0,0,255, 255));
        Iplayer.fillRect(playerPos(player[2])[0]+60,playerPos(player[2])[1] , 30, 10);
    }
    /***
     * Iteam - set the image for the team choice
     */
    public void Iteam()
    {
        Iteam.clear();
        Iteam.setColor(new Color(0,0,0,255));
        Font font = image.getFont();
        font = font.deriveFont(17);
        Iteam.setFont(font);
        Iteam.setColor(new Color(255,0,0,255));
        Iteam.drawString(text[18+team[0]],100 , 480);
        Iteam.setColor(new Color(0,255,0,255));
        Iteam.drawString(text[18+team[1]],220 , 480);
        Iteam.setColor(new Color(0,0,255,255));
        Iteam.drawString(text[18+team[2]],160 , 520);
    }
    /**
     * IgameMode - set the image for the game mode
     */
    public void IgameMode()
    {
        IgameMode.clear();
        IgameMode.setColor(new Color(10,10,10,200));
        if(gameMode==0)
        {
            IgameMode.fillRect(585,120,180,300);
            IgameMode.fillRect(770,120,180,300);
            IgameMode.fillRect(955,120,180,300);
        }
        if(gameMode==1)
        {
            IgameMode.fillRect(400,120 ,180,300);
            IgameMode.fillRect(770,120,180,300);
            IgameMode.fillRect(955,120,180,300);
        }
        if(gameMode==2)
        {
            IgameMode.fillRect(400,120 ,180,300);
            IgameMode.fillRect(585,120,180,300);
            IgameMode.fillRect(955,120,180,300);
        }
        if(gameMode==3)
        {
            IgameMode.fillRect(400,120 ,180,300);
            IgameMode.fillRect(585,120,180,300);
            IgameMode.fillRect(770,120,180,300);
        }
        
        IgameMode.setColor(new Color(0,0,0,255));
        Font font = image.getFont();
        font = font.deriveFont(18);
        IgameMode.setFont(font);
        IgameMode.drawString(String.valueOf(modeInfo[0]),440 , 395);
        IgameMode.drawString(String.valueOf(modeInfo[1]),625 , 395);
        IgameMode.drawString(String.valueOf(modeInfo[2]),810 , 395);
    }
    /**
     * playerPos - calculate the position of the player
     */
    public int[] playerPos(int x){
    int[] ret = {85,210};
    if(x==1 || x==3)
    {
        ret[0] = 205;
    }
    if(x==2 || x==3)
    {
        ret[1] = 330;    
    }
    
    return ret;
    }
    /**
     * Update - update the image
     */
    public void Update()
    {
        menu.clear();
        menu.drawImage(image, 0, 0);
        menu.drawImage(Iteam,0,0);
        menu.drawImage(Iplayer,0,0);
        menu.drawImage(IgameMode,0,0);
        setImage(menu);
    }
    /**
     * start - start the game
     */
    public void start()
    {
        Smenu.stop();
        if(team[0]==team[1] && team[1]==team[2] && team[0]==team[2]){team[0]=0;team[1]=1;team[2]=2;}
        if(team[0]==team[1] && team[2]==3){team[0]=0;team[1]=1;}
        if(team[1]==team[2] && team[0]==3){team[1]=0;team[2]=1;}
        if(team[0]==team[2] && team[1]==3){team[0]=0;team[2]=1;}
        int info=0;
        if(gameMode!=3)
        {
            info = modeInfo[gameMode];
            if(info==0)
            {
                info=1;
            }
        }
        
        land.startGame(player[0],player[1],player[2],team[0],team[1],team[2],gameMode,info,player[0],player[1],player[2]);
    }
}
