import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * a variation of a SmoothMover that can interact with the player's movement and/or affect him.
 * 
 * @author Romuald Apothélos
 * @author Boris Méan 
 * 
 * @version 20.12.2021
 */
public class Obstacle extends SmoothMover
{
    public int height;
    public int width;
    public int type;
    public int life;
    public boolean ground;
    public Actor Destroyer;
    /**
     * Obstalce - instanciate the class Flag
     */
    public Obstacle(int x)
    {
        type=x;
        if(type==0)
        {
           height=30;
           width=30;
           life = 80;
           setImage(new GreenfootImage("crate.png"));
        }
        else if(type==1)
        {
           height=25;
           width=15;
           life = 120;
           setImage(new GreenfootImage("fuel.png"));
        }
    }
    /**
     * Act - do whatever the obstacle wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
       Vector movement = getMovement();
        boolean ground = false;
        if (onGround(movement,height)){ground=true;}; 
        gravity(movement,ground);
        friction(movement);
        wallchek(movement);
        move(); 
        if(life<0)
        {
            if(type==1)
            {
               explod(Destroyer); 
               setfire(Destroyer);
            }
            getWorld().removeObject(this);
            return;
        }
    }
    /**
     * Friction - apply friction to the horizontal movement
     */
    public void friction(Vector movement)
    {
        double friction = 0.02;
        if(ground == true){friction=0.05;}
        if(movement.getX()>0.05)
        {
                addForce (new Vector (-friction, 0.0));
        }
        if(movement.getX()<-0.05)
        {
                addForce (new Vector (friction, 0.0));
        }
        if(movement.getX()>-0.05 && movement.getX()<0.05)
        {
                addForce (new Vector (-movement.getX(), 0.0));
        }
    }
    /**
     * Wallchek - check if the object is near a wall and stop him form moving any further
     */
    public void wallchek(Vector movement)
    {
        if(onWall(movement,width)==1 && movement.getX()<=0){
            addForce(new Vector(-movement.getX(),0));
        }else if(onWall(movement,width)==2 && movement.getX()>=0){
            addForce(new Vector(-movement.getX(),0));
        }
    }
    public int getHeight()
    {
        return height;
    }
    public int geWidth()
    {
        return width;
    }
    public void destroy(int damage,Actor player)
    {
        life=life-damage;
        Destroyer = player;
    }
}
