import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A Class that allows the player to move on it, but also used to make the weapons and others appear.
 * 
 * @author Romuald Apothélos
 * @author Boris Méan 
 * 
 * @version 15.12.2021
 */
public class Platform extends Actor
{
    boolean crossable;
    boolean spawnable;
     /**
     * Platfrom - contructor of the class Platform
     */
    public Platform(boolean yes, boolean too)
     {
         crossable = yes;
         spawnable = too;
     }
    /**
     * Act - do whatever the Platform wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        if(Greenfoot.getRandomNumber(15000)==0 && spawnable) 
        {
            getWorld().addObject(new weapon(),getX()-20,getY()-10);
        }
    }
    /**
     * Populate - put randomly objects on top of the platform
     */
    public void populate()
    {
        if(Greenfoot.getRandomNumber(100)>70)
        {
                if(Greenfoot.getRandomNumber(1)>0)
                {
                     getWorld().addObject(new Obstacle(0),getX()-20,getY()-30);  
                     if(Greenfoot.getRandomNumber(100)>90)
                    {
                        getWorld().addObject(new Obstacle(1),getX()+25,getY()-25); 
                    }
                }
                else
                {
                     getWorld().addObject(new Obstacle(0),getX()+20,getY()-30);  
                      if(Greenfoot.getRandomNumber(100)>90)
                    {
                        getWorld().addObject(new Obstacle(1),getX()-25,getY()-25); 
                    }
                }
        }
        else if(Greenfoot.getRandomNumber(100)>90)
        {
           if(Greenfoot.getRandomNumber(1)>0)
                {
                     getWorld().addObject(new Obstacle(1),getX()-25,getY()-25);  
                     if(Greenfoot.getRandomNumber(100)>90)
                    {
                        getWorld().addObject(new Obstacle(1),getX()+25,getY()-25); 
                    }
                }
                else
                {
                     getWorld().addObject(new Obstacle(1),getX()+25,getY()-25);  
                      if(Greenfoot.getRandomNumber(100)>90)
                    {
                        getWorld().addObject(new Obstacle(1),getX()-25,getY()-25); 
                    }
                } 
        }
    }
    /**
     * Clear - say if you can go to through the plaftform
     */
    public boolean clear()
    {
       return crossable; 
    }
    /**
     * Spawn - put a player on top of the platforme
     */
    public void spawn(Player player)
    {
        getWorld().addObject(player,getX(),getY()-40);
    }
}
