import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import greenfoot.Actor;

/**
 * An avatar that allows the player to interact with the world.
 * 
 * @author Romuald Apothélos
 * @author Boris Méan 
 * 
 * @version 15.01.2022
 */
public class Player extends SmoothMover
{
    public int clock = 0;
    public boolean ground = false;
    public boolean wallR = false;
    public boolean wallL = false;
    public int key; 
    public String[][] keySet = {{"a","s","d","w","f","q","e"},{"g","h","j","z","k","t","u"},{"left","down","right","up","-",",","."}};
    public String[] avatar = {"armailli.png","culotte.png","genevois.png","vache.png","Berset.png"};
    public int life = 100;
    public int stamina = 500;
    public int maxstamnia = 500;
    public int[][] invten = {{5,10},{5,20,20},{0,3,20},{0}};
    public int type = 1;
    public int waitType = 0;
    public int[][] weapon = {{10,10},{20,20},{40,40},{100,20},{10,20,20},{10,5,40},{2,30,10},{1,5,100},{40,30,5},{50,50,6},{100,20,999},{0,20,3},{1,20,3},{2,20,3},{1},{2},{3},{4},{5},{6}};
    public int[] jeuDArm = {8,6,7,5,4,2};
    public boolean aiming = false;
    public int waitaim = 0;
    public boolean faceLeft = false;
    public int aimAngle = 0;
    public int waitAngle;
    public int waitTp;
    public lifeBar lifbar;
    public UI ui = new UI();
    public int maxLife = 100;
    public int speed;
    public boolean slow = false;
    public int team;
    public int gMode;
    public int kill;
    public int death;
    public int kills;
    public int waitHurt = 100;
    public int info;
    public int image;
    /**
     * Constructur of player with different key Set
     */
    public Player(int keyType, int GM, int TM,int lastKill, int lastdeath, int inf,int im)
    {
        image = im;
        if(im==4){berset();}
        this.key = keyType;
        setImage(new GreenfootImage(avatar[im]));
        team = TM;
        gMode = GM;
        kill = lastKill;
        death = lastdeath;
        kills = 0;
        info = inf;
        if(GM==3)
        {
            newWeapon();
            invten[2][1] = 0;
        }
    }
    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        game();
        applyForces();
        if(clock>speed && slow){Greenfoot.setSpeed(49);slow=false;}
        clock++;
    }
    /**
     * ApplyForces - apply the forces and move the player 
     */
    public void applyForces()
    {
        Vector movement = getMovement();
        ground = false;
        if(onGround(movement, 40)){ground=true;};
        onTop(movement, 40);
        wallchek(movement);
        gravity(movement, ground);
        friction(movement);
        run(movement);
        door(movement);
        if(died()){return;};
        move();
        info();
    }
    /**
     * Wallchek - check if the player is near a wall and stop him form moving any further
     */
    public void wallchek(Vector movement)
    {
        wallR = false;
        wallL = false;
        if(onWall(movement,15)==1 && movement.getX()<=0){
            wallL=true;
            addForce(new Vector(-movement.getX(),0));
        }else if(onWall(movement,15)==2 && movement.getX()>=0){
            wallR=true;
            addForce(new Vector(-movement.getX(),0));
        }
    }
    /**
     * run - transalte the key inputs to a vectore or action
     */
    public void run(Vector movement)
    {
        if(waitAngle<clock){aimAngle=0;};
        Aim aim = new Aim(keySet[key][0],keySet[key][2],faceLeft,keySet[key][4],keySet[key][5],this,keySet[key][1],keySet[key][3],aimAngle,invten[type][0]);
        if(aimAngle>180 && aimAngle<269){aim.setLeft();}
        if (Greenfoot.isKeyDown(keySet[key][0]) && !wallL && !aiming) 
        {
            if(movement.getX()>=-6 && stamina>=10)
            {
                addForce (new Vector (-0.2, 0.0));
            }else if(movement.getX()>=-3)
            {
                addForce (new Vector (-0.2, 0.0));
            }
            facing(movement);
        }
        if (Greenfoot.isKeyDown(keySet[key][1]) && ground && !aiming && getOneIntersectingObject(weapon.class)==null)
        {
            goDown();
        }
        if (Greenfoot.isKeyDown(keySet[key][2]) && !wallR && !aiming) 
        {
            if(movement.getX()<=6 && stamina>=10)
            {
                addForce (new Vector (0.2, 0.0));
            }else if(movement.getX()<=3)
            {
                addForce (new Vector (0.2, 0.0));
            }
            facing(movement);
        }
        if (Greenfoot.isKeyDown(keySet[key][3]) && !aiming) 
        {
            if(movement.getY()==0 && stamina>=20)
            {
                 addForce (new Vector (0.0, -5.3));
            }
            else if(movement.getY()==0)
            {
                 addForce (new Vector (0.0, -3));
            }
        }
        if(Greenfoot.isKeyDown(keySet[key][4]) && clock>waitaim && ground)
        {
            if(!aiming && (type==1 || type==2) && invten[type][1]>0)
            {
                aiming = true;
                getWorld().addObject(aim,getX(),getY());
                addForce(new Vector(-movement.getX(),-movement.getY()));
            }
            if(type==3)
            {
                shoot();
                invten[3][0]=0;
            }
        }
        if(Greenfoot.isKeyDown(keySet[key][5]) && !aiming && clock>waitaim)
        {
            if((type==1 || type==2) && invten[type][1]>0)
            {
            shoot();
            mun();
            }
            if(type==0)
            {
                hit();
            }
            if(type==3)
            {
                shoot();
                invten[3][0]=0;
            }
        }
        if (Greenfoot.isKeyDown(keySet[key][1]) && getOneIntersectingObject(weapon.class)!=null)
        {
            changeWeapon(getOneIntersectingObject(weapon.class));
            getWorld().removeObject(getOneIntersectingObject(weapon.class));
        }
        if (Greenfoot.isKeyDown(keySet[key][6]) && waitType<=clock && !aiming)
        {
            waitType = clock+10;
            type=((type+1)%4);
        }
        if(movement.getX()!=0 && stamina>=0)
        {
          stamina--;  
        }
        else if(stamina<=maxstamnia)
        {
           stamina=stamina+2; 
        }
    }
    /**
     * Facing - ceck wath direction the player is facing
     */
    public void facing(Vector movement)
    {
        if(movement.getX()>0){faceLeft = false;}
        if(movement.getX()<0){faceLeft = true;}
    }
    /**
     * Friction - apply friction to the horizontal movement
     */
    public void friction(Vector movement)
    {
        double friction = 0.02;
        if(ground == true){friction=0.05;}
        if(movement.getX()>0.05 && !Greenfoot.isKeyDown(keySet[key][0]))
        {
                addForce (new Vector (-friction, 0.0));
        }
        if(movement.getX()<-0.05 && !Greenfoot.isKeyDown(keySet[key][2]))
        {
                addForce (new Vector (friction, 0.0));
        }
        if(movement.getX()>-0.05 && movement.getX()<0.05)
        {
                addForce (new Vector (-movement.getX(), 0.0));
        }
    }
    /**
     * shoot() - change the valeur of the variable aiming to false and shoot;
     */
    public void shoot()
    {
        int sp = 0;
        if(invten[type][0]==50){sp=1;}
        else if(invten[type][0]==100){sp=2;};
        int angle=aimAngle;
        if(faceLeft && angle==0){angle=angle+180;};
        if(invten[1][0]==2 && type==1)
        {
            for(int i=0;i<10;i++)
            {
               getWorld().addObject(new Bullet((angle+i-5),this,invten[type][0],sp),getX()+Greenfoot.getRandomNumber(5)-5,getY()+Greenfoot.getRandomNumber(5)-5); 
            }
        }
        if(invten[1][0]==1 && type==1)
        {
            GroundSticker gs =new GroundSticker(0,this);
            if(angle>90 && angle<270)
            {
                getWorld().addObject((gs),getX()-30,getY());
            }
            else
            {
               getWorld().addObject((gs),getX()+30,getY()); 
            } 
            gs.addForce(new Vector(angle+Greenfoot.getRandomNumber(40)-20,7.0));
        }
        else 
        {
            if(type==1)
            {
                getWorld().addObject(new Bullet(angle,this,invten[type][0],sp),getX(),getY());
            }
            else if(type==2)
            {
                getWorld().addObject(new thrower(angle,invten[type][0],this),getX(),getY());
            }
            else if(type==3)
            {
                if(invten[3][0]==1)
                {
                    life=maxLife;
                }
                if(invten[3][0]==2)
                {
                    maxLife=maxLife+10;
                    life=maxLife;
                }
                if(invten[3][0]==3)
                {
                    maxLife=maxLife-10;
                    life=maxLife;
                }
                if(invten[3][0]==4)
                {
                    Greenfoot.setSpeed(35);
                    speed=clock+100;
                    slow=true;
                }
                if(invten[3][0]==5)
                {
                   stamina=500; 
                }
            }
        }
        setAimAngle(aimAngle);
        aiming=false;
        if(type!=3){waitaim=clock+invten[type][2];}
    }
    /**
     * shoot() - change the valeur of the variable aiming to false and shoot;
     */
    public void shoot(int i)
    {
        setAimAngle(aimAngle);
        aiming=false;
        waitaim=clock+invten[type][2];
    }
    /**
     * SetAimAngle - let the aim set an non permanant defaul angle, let the player shoot multipel time in the same direction
     */
    public void setAimAngle(int x)
    {
        aimAngle=x;
        waitAngle=clock+60;
    }
    /**
     * Door - check if the player is next to a door and then teleport it.
     */
    public void door(Vector movement)
    {
        if(getX()>1170 && getY()>500 && clock>waitTp)
        {
            setLocation(1175,300);
            waitTp=clock+30;
            addForce(new Vector(-2*movement.getX(),0));
        }
        else if(getX()>1170 && getY()>300 && getY()<400 && clock>waitTp)
        {
            setLocation(1175,540);
            waitTp=clock+30;
            addForce(new Vector(-2*movement.getX(),0));
        }
    }
    /**
     * Died - check if the player is dead
     */
    public boolean died()
    {
      if(life<=0)
      {
          death++;
          List<Platform> plat = (List<Platform>) getWorld().getObjects(Platform.class);
          plat.get(Greenfoot.getRandomNumber(plat.size())).spawn(new Player(key,gMode,team,kill,death,info,image));
          getWorld().removeObject(lifbar);
          getWorld().removeObject(ui);
          getWorld().removeObject(this);
          return true;
      };
      return false;  
    }
    /**
     * Hurt - decrease the life
     */
    public void hurt(int damage,Actor killer)
    {
        if(clock>waitHurt){
        life=life-damage;
        GreenfootSound sound= new GreenfootSound("hurt.mp3");
        sound.play();
        sound.setVolume(40);
        if(life<=0 && killer!=this)
        {
            List<Player> player = (List<Player>) getWorld().getObjects(Player.class);
            for (Player play : player) 
            {
                if (play==killer )
                {
                   play.kill();
                   waitHurt=1000+clock;
                }
            }
        }
        }
    }
    /**
     * info - put a bar that show the stamnia and 
     */
    public void info()
    {
        if(lifbar == null)
        {
            lifbar = new lifeBar();
            getWorld().addObject(lifbar,getX(),getY()-50);
            ui = new UI();
            getWorld().addObject(ui, 200+400*key, 40);
        }
        lifbar.updateImage(life,stamina);
        lifbar.setLocation(getX(),getY()-50);
        int im1 = 0;
        int im2 = 0;
        int im3 = 0;
        if(invten[0][0]>5)
        {
            im1 = invten[0][0]/10;
        }
        if(im1==4){im1--;};
        if(im1==10){im1=4;}
        if(invten[1][1]>0){
            if(invten[1][0]==5 || (invten[1][0]==10 && invten[1][2]==20))
            {
                im2=1;
            }
            else if(invten[1][0]==10 && invten[1][2]==5)
            {
                im2=2;
            }
            else if(invten[1][0]==2)
            {
                im2=3;
            }
            else if(invten[1][0]==1)
            {
                im2=4;
            }
            else if(invten[1][0]==40)
            {
                im2=5;
            }
            else if(invten[1][0]==50)
            {
                im2=6;
            }
            else if(invten[1][0]==100)
            {
                im2=7;
            }
        }
        if(invten[2][1]>0){
            im3=1+invten[2][0];
        }
        ui.update(life,stamina,invten[1][1],invten[2][1],type,im1,im2,im3,invten[3][0],kill,death,kills);
    }
    /**
     * goDown - go down a platform
     */
    public void goDown()
    {
        List<Platform> platfrom = (List<Platform>) getWorld().getObjects(Platform.class);
        for (Platform plat : platfrom) 
        {
            if (plat.getX()+50>this.getX() && plat.getX()-50<this.getX() && plat.getY()-4<=this.getY()+40 && plat.getY()+4>=this.getY()+40 )
            {
               if(plat.clear()==true)
                {
                    setLocation(getX(), getY()+10);
                    addForce (new Vector (0.0, 1));
                }
            }
        }
        
    }
    /**
     * Mun - reduce the number of munition
     */
    public void mun()
    {
        if(type!=0)
        {
            invten[type][1]=invten[type][1]-1;
            if(invten[type][1]<=0 && gMode == 3)
            {
                if(kill-death>=0){invten[1][1] = weapon[jeuDArm[(kill-death)]][2];}
                else{invten[1][1] = weapon[jeuDArm[0]][2];}
            }
        }
        
    }
    /**
     * Hit - deal damage to an ennemy in front of the player
     */
    public void hit()
    {
        List<Player> player = (List<Player>) getWorld().getObjects(Player.class);
        List<Obstacle> obstacle = getObjectsInRange(150, Obstacle.class);
        for (Player play : player) 
        {
            if ((play!=this && faceLeft && play.getY()<=this.getY()+40 && play.getY()>=this.getY()-40 && play.getX()<=this.getX()-15 && play.getX()>=this.getX()-50)||(play!=this && !faceLeft && play.getY()<=this.getY()+40 && play.getY()>=this.getY()-40 && play.getX()>=this.getX()+15 && play.getX()<=this.getX()+50))
            {
               play.hurt(invten[0][0],this);
               waitaim=clock+invten[type][1];
            }
        }
        for (Obstacle obs : obstacle) 
        {
            if (( faceLeft && obs.getY()<=this.getY()+40 && obs.getY()>=this.getY()-40 && obs.getX()<=this.getX()-15 && obs.getX()>=this.getX()-50)||(!faceLeft && obs.getY()<=this.getY()+40 && obs.getY()>=this.getY()-40 && obs.getX()>=this.getX()+15 && obs.getX()<=this.getX()+50))
            {
               obs.destroy(invten[0][0],this);
               waitaim=clock+invten[type][1];
            }
        }
    }
    /**
     * ChangeWeapon - update the weapon and the amunition
     */
    public void changeWeapon(Actor actor)
    {
      List<weapon> weapon = (List<weapon>) getWorld().getObjects(weapon.class);
      for (weapon we : weapon) 
      {
          if(we.getX() == actor.getX() && we.getY() == actor.getY())
          {   
              if(we.getType()<3)
              {
                  invten[0][0] = this.weapon[we.getType()][0];
                  invten[0][1] = this.weapon[we.getType()][1];
              }
              else if(we.getType()>2 && we.getType()<=8)
              {
                  invten[1][0] = this.weapon[we.getType()+1][0];
                  invten[1][2] = this.weapon[we.getType()+1][1];
                  invten[1][1] = this.weapon[we.getType()+1][2];
              }
              else if(we.getType()>=9 && we.getType()<=11)
              {
                  invten[2][0] = this.weapon[we.getType()+2][0];
                  invten[2][2] = this.weapon[we.getType()+2][1];
                  invten[2][1] = this.weapon[we.getType()+2][2];
              }
              else if(we.getType()>=12)
              {
                  invten[3][0] = this.weapon[we.getType()+2][0];
              }
          }
      }
    }
    /**
     * game - apply the gamemode
     */
    public void game()
    {
        if(gMode==1)
        {
            if(kill>=info)
            getWorld().addObject(new GameOver(team),600,300);
        }
        else if(gMode==2)
        {
            if(kills>=info)
            getWorld().addObject(new GameOver(team),600,300);
        }
        else if(gMode==3)
        {
            if((kill-death)>=6)
            {
            getWorld().addObject(new GameOver(team),600,300);
            }
        }
    }
    /**
     * Kill - augment the number of the kill
     */
    public void kill()
    {
        kill++;
        kills++;
        if(gMode==3)
                   {
                       if(kill<death){kill=death+1;}
                       newWeapon();
                   }
    }
    /**
     * newWeapon - change the weapon in the gamemode "jeux d'arme"
     */
    public void newWeapon()
    {
        if((kill-death)==5){
           type=0; 
           invten[0][0] = weapon[jeuDArm[(kill-death)]][0];
           invten[0][1] = weapon[jeuDArm[(kill-death)]][1];
           invten[1][0] = 0;
           invten[1][2] = 0;
           invten[1][1] = 0;
        }
        else if((kill-death)>=0 && (kill-death)<6)
        {
           invten[1][0] = weapon[jeuDArm[(kill-death)]][0];
           invten[1][2] = weapon[jeuDArm[(kill-death)]][1];
           invten[1][1] = weapon[jeuDArm[(kill-death)]][2]; 
        }
        else if((kill-death)<0)
        {
           invten[1][0] = weapon[jeuDArm[0]][0];
           invten[1][2] = weapon[jeuDArm[0]][1];
           invten[1][1] = weapon[jeuDArm[0]][2]; 
        }
    }
    /**
     * getTeam - return the team of the player
     */
    public int getTeam()
    {
        return team;
    }
    /**
     * getKey - returnr the key of the player
     */
    public int getKey()
    {
        return key;
    }
    /**
     * getKill - return the number of kill
     */
    public int getKill()
    {
        return kill;
    }
    /**
     * berset - easteregg
     */
    public void berset()
    {
        image=4;
        setImage(new GreenfootImage(avatar[4]));
        invten[0][0] = weapon[3][0];
        invten[0][1] = weapon[3][1];
        invten[1][0] = weapon[10][0];
        invten[1][2] = weapon[10][1];
        invten[1][1] = weapon[10][2];
    }
}
