import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * An interface that gives information about the character to the players
 * 
 * @author Romuald Apothélos
 * @author Boris Méan 
 * 
 * @version 15.01.2022
 */
public class UI extends Actor
{
    public int width = 300;
    public int height = 80;
    public int uLife = 80;
    public int uStamina = 80;
    public int type = 0;
    public String[][] kill = {{"K: ","D: ","KS:"},{"0","0","0"}};
    GreenfootImage ui = new GreenfootImage(width, height);
    public int[][] invent = {{0},{0,0},{0,0},{0,0}};
    public int[] intImage = {0,0,0,1};
    public String[][] image = {{"U.hand.png","U.Knife.png","U.axe.png","U.halbard.png","vaccin.png"},{"no.png","U.handgun.png","U.Fass-90.png","U.pomp.png","U.flamethrower.png","U.Snipe.png","U.arbalet.png","pass.png"},{"no.png","U.grenade.png","U.moltov.png","U.fondu.png"},{"no.png","U.choco.png","U.suze.png","U.absinte.png","U.clock.png","U.cor.png"}};
    /**
     * Act - do whatever the UI wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        draw();
    }
    /**
     * Draw - draw the image and set in on the screen
     */
    public void draw()
    {
        ui.clear();
        ui.setColor(new Color(0,0,0,125));
        ui.fillRect(0,0,width,height);
        Font font = ui.getFont();
        font = font.deriveFont(20);
        ui.setFont(font);
        for(int i = 0; i<4;i++)
        {
          ui.setColor(new Color(255,255,255,125));
          if(type==i){ui.setColor(new Color(255,255,255,255));}
          ui.fillRect(10+i*55,10,45,45);
          ui.drawImage(new GreenfootImage(image[i][intImage[i]]),15+i*55,15);
          ui.setColor(new Color(255,255,255,255));
        }
        for(int i=1;i<3;i++)
        {
            ui.drawString(String.valueOf(invent[i][1]),15+i*55,75);
        }
        font = font.deriveFont(16);
        ui.setFont(font);
        for(int i = 0; i<3;i++)
        {
          ui.drawString((kill[0][i]+kill[1][i]),225,20+i*25); 
        }
        ui.setColor(new Color(255,255,255,255));
        ui.fillRect(280,80-uStamina,10,uStamina);
        ui.setColor(new Color(255,0,0,255));
        ui.fillRect(290,80-uLife,10,uLife);
        
        setImage(ui);
    }
    /**
     * Update - update the value of the ui
     */
    public void update(int life, int stamina, int inv1, int inv2, int type,int im1,int im2,int im3, int im4,int k, int d, int ks)
    {
        uLife = (int) ((double)80/100*life);
        uStamina = (int) ((double)80/500*stamina);
        invent[1][1] = inv1;
        invent[2][1] = inv2;
        intImage[0] = im1;
        intImage[1] = im2;
        intImage[2] = im3;
        intImage[3] = im4;
        this.type = type;
        kill[1][0] = Integer.toString(k);
        kill[1][1] = Integer.toString(d);
        kill[1][2] = Integer.toString(ks);
    }
}
