import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Visually shows the player's life and stamina with a bar above his head.
 * 
 * @author Romuald Apothélos
 * @author Boris Méan 
 * 
 * @version 22.12.2021
 */
public class lifeBar extends Actor
{
    public static final int width = 50;
    public static final int height = 5;
    
    /**
     * Create a life bar
     */
    public lifeBar()
    {
        GreenfootImage image = new GreenfootImage(width, 6*height);
        image.setColor(new Color(255,255,255, 128));
        image.fillRect(0, 0, width, height);
        image.fillRect(0, 2*height, width, height);
        
        image.setColor(new Color(255,0,0, 200));
        image.fillRect(0, 0, 20, height);
        image.setColor(new Color(255,255,255, 200));
        image.fillRect(0, 2*height, width, height);
        
        setImage(image);
    }

    /**
     * update the life of the actor and display him.
     */
    public void updateImage(int life, int stamina)
    {
        GreenfootImage image = new GreenfootImage(width, 6*height);
        image.setColor(new Color(255,255,255, 128));
        image.fillRect(0, 0, width, height);
        image.fillRect(0, 2*height, width, height);
        
        int lifebar = (int) (life*((double)width/100));
        image.setColor(new Color(255,0,0, 200));
        image.fillRect(0, 0, lifebar, height);
        int staminabar = (int) (stamina*((double)width/500));
        image.setColor(new Color(255,255,255, 200));
        image.fillRect(0, 2*height, staminabar, height);
        
        setImage(image);
    }
}
