import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The set of objects thrown by the player that describe a parabolic trajectory.
 * 
 * @author Romuald Apothélos
 * @author Boris Méan 
 * 
 * @version 13.01.2022
 */
public class thrower extends SmoothMover
{
    public int type;
    public boolean ground = false;
    public int time = 0;
    public Actor killer;
    /**
     * contructor of the class thrower
     */
    public thrower(int rotation, int tp, Actor player)
    {
        addForce(new Vector(rotation,7.0));
        type = tp;
        killer = player;
        if(tp==0)
        {
           setImage(new GreenfootImage("t.grenade.png"));
        }
        else if(tp==1)
        {
            setImage(new GreenfootImage("t.moltov.png"));
        }
        else
        {
           setImage(new GreenfootImage("t.fondu.png")); 
        }
    }
    /**
     * Act - do whatever the thrower wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        Vector movement = getMovement();
        ground=false;
        if(onGround(movement, 5)){ground=true;}
        gravity(movement, ground);
        friction(movement);
        wallchek(movement);
        move();
        special();
        time++;
    }
    /**
     * Friction - apply friction to the horizontal movement
     */
    public void friction(Vector movement)
    {
        double friction = 0.02;
        if(ground == true){friction=0.05;}
        if(movement.getX()>0.05)
        {
                addForce (new Vector (-friction, 0.0));
        }
        if(movement.getX()<-0.05)
        {
                addForce (new Vector (friction, 0.0));
        }
        if(movement.getX()>-0.05 && movement.getX()<0.05)
        {
                addForce (new Vector (-movement.getX(), 0.0));
        }
    }
    /**
     * Wallchek - check if the object is near a wall and stop him form moving any further
     */
    public void wallchek(Vector movement)
    {
        if(onWall(movement,10)==1 && movement.getX()<=0){
            addForce(new Vector(-movement.getX(),0));
        }else if(onWall(movement,10)==2 && movement.getX()>=0){
            addForce(new Vector(-movement.getX(),0));
        }
    }
    /**
     * Special - enable the special ability of the thrower
     */
    public void special()
    {
      if(type==0 && time>200)
      { 
          explod(killer);
          getWorld().removeObject(this);
      }
      else if(type==1 && ground && time>20)
      {
          setfire(killer);
          getWorld().removeObject(this);
      }
      else if(type==2 && ground && time>20)
      {
          getWorld().addObject(new GroundSticker(1,killer),getX(),getY());
          getWorld().removeObject(this);
      }
    }
}
